<?php
/**
 * SimpleXMLExtended Class
 *
 * Extends the default PHP SimpleXMLElement class by 
 * allowing the addition of cdata
 *
 * @since 1.0
 *
 * @param string $cdata_text
 */
class SimpleXMLExtended extends SimpleXMLElement{   
  public function addCData($cdata_text){   
   $node= dom_import_simplexml($this);   
   $no = $node->ownerDocument;   
   $node->appendChild($no->createCDATASection($cdata_text));   
  } 
} 

/**
 * Get XML Data
 *
 * Turns the XML file into an object 
 *
 * @since 1.0
 *
 * @param string $file
 * @return object
 */
function getXML($file) {
	$xml = file_get_contents($file);
	$data = simplexml_load_string($xml, 'SimpleXMLExtended', LIBXML_NOCDATA);
	return $data;
}

/**
 * XML Save
 *
 * @since 2.0
 * @todo create and chmod file before ->asXML call (if it doesnt exist already, if so, then just chmod it.)
 *
 * @param object $xml
 * @param string $file Filename that it will be saved as
 * @return bool
 */
function XMLsave($xml, $file) {
	$success = $xml->asXML($file) === TRUE;
}

/**
 * Clean URL
 *
 * @since 1.0
 *
 * @param string $text
 * @return string
 */
function clean_url($text)  { 
	$text = strip_tags(strtolower($text)); 
	$code_entities_match = array(' ?',' ','--','&quot;','!','@','#','$','%','^','&','*','(',')','+','{','}','|',':','"','<','>','?','[',']','\\',';',"'",',','/','*','+','~','`','=','.'); 
	$code_entities_replace = array('','-','-','','','','','','','','','','','','','','','','','','','','','','','',''); 
	$text = str_replace($code_entities_match, $code_entities_replace, $text); 
	$text = urlencode($text);
	$text = str_replace('--','-',$text);
	$text = rtrim($text, "-");
	return $text; 
} 

include ("traducir.php");
$tr_cont= traducir1();
//-----------------------------------------------------------------//
//-----------------------------------------------------------------//
//-----------------------------------------------------------------//
  $err='';
  session_start();
  $imagenCadena = $_SESSION["imagencadena"]; 
  $pot = trim(strtolower($imagenCadena));
  $server_name = getenv ("SERVER_NAME");       // Server Name
  $request_uri = getenv ("REQUEST_URI");       // Requested UR

//------------------------
//START CONTACT
//------------------------
 if (@$_GET['tp'] == 'contact') { 

	if (isset($_POST['contact-submit'])) {
	         $log_file= $_POST['contact']['q_file'];
                 $EMAIL = $_POST['contact']['q_email'];
		 $MIURL = $_POST['contact']['q_uri'];
		 $posmiar= strpos($MIURL, 'miarr=');
                 if ($posmiar){
		      $MIURL = substr($MIURL,0, $posmiar - 1);	 
 		      $_POST['guest']['q_uri'] = $MIURL;
		 }

	         if ( $pot == trim(strtolower($_POST['contact']['pot']))) {
        	      $captcha = $_POST['contact']['pot'];
        	 }
	         else {
 		 	$err = $tr_cont['MSG_CAPTCHA_FAILED'];
		 }

		 if ( $_POST['contact']['email'] != '' ) {
                      if ($_POST['contact']['email']!= $tr_cont['em_text']){
			$from = $_POST['contact']['email'];
                      } else {
                        $_POST['contact']['email']='---';
		      }
                 }
		 if ( $_POST['contact']['tema'] != '' ) {
			$subject = $_POST['contact']['tema'];
		 } else { 
			$subject = '';
		 } 

		$temp = $_POST['contact'];
		$captcha = $_POST['contact']['pot'];
                $temp['Mensaje'] = $_POST['Mensaje'];

		if ($err == '' && trim($_POST['contact']['email']) !='' && trim($_POST['Mensaje']) !='') {

			$headers = "From: ".$from."\r\n";
			$headers .= "Return-Path: ".$from."\r\n";
			$headers .= "Content-type: text/html; charset=UTF-8 \r\n";

			unset($temp['pot']);
			unset($temp['contact-submit']);
			unset($temp['submit']);

			$body = $CONTACT_FORM_SUB.' '.$WHO.' http://'.$server_name.$request_uri.' <br />';
			$body .= "-----------------------------------<br /><br />";


			if ( ! file_exists($log_file) ) {
               			 $xml = new SimpleXMLExtended('<channel></channel>');
			} else
			{
				$xmldata = file_get_contents($log_file);
		                $xml = new SimpleXMLExtended($xmldata);
			}

			$thislog = $xml->addChild('entry');
			$thislog->addChild('date', date('r'));
			$cdata = $thislog->addChild('from');
			$cdata->addCData($from);
			$cdata = $thislog->addChild('subject');
			$cdata->addCData(htmlentities($subject, ENT_QUOTES, 'UTF-8'));
			$cdata = $thislog->addChild('captcha');
			$cdata->addCData($captcha);
			$cdata = $thislog->addChild('ip_address');
			$ip = getenv("REMOTE_ADDR"); 
			$cdata->addCData(htmlentities($ip, ENT_QUOTES, 'UTF-8'));
                        $body .= "Ip: ". $ip ."<br />"; 
			foreach ( $temp as $key => $value ) {
			    if (substr($key, 0, 2) != 'q_') {
				$body .= ucfirst($key) .": ". $value ."<br />";
				$cdata = $thislog->addChild(clean_url($key));
				$cdata->addCData(htmlentities($value, ENT_QUOTES, 'UTF-8'));
			    }
			}
			$result = mail($EMAIL,$subject,$body,$headers);

			XMLsave($xml, $log_file);

			//results	
                        $seg = 2;  		
			if ($result=='1') {
				echo $tr_cont['MSG_CONTACTSUC'].'<br /><br />';
			} else {
				echo '<p>'.$tr_cont['MSG_guestERR'].'</p><br />';
			}
		} else { //finaliza if err=''
                            $miarr = '';
                            $miarr = serialize($temp);
                            $miarr = urlencode($miarr);
                            if (strpos($MIURL, '?')){
                                $miarr = '&amp;miarr='.$miarr;
                            } else {
                                $miarr = '?miarr='.$miarr;
                            }    
                            //Si hay algún error en captcha ó campos vacíos.
                             $seg=4;
		     if (trim($err) !=''){
			echo '<p>'.$err.'.<br />Captcha code: '.$pot.'<br / >Code wrote: '.$_POST['contact']['pot'].'</p><br /><br />';
		     }
	             else {
			     	echo '<font color="red">*** '.strtoupper($tr_cont['Co']).' ***</font><br /><br />';
		     }
		}

	}
  }

  echo '<html>';
  echo '<head>';
  echo '<meta http-equiv="Refresh" content="'.$seg.';url=http://'.$server_name.$MIURL.$miarr.'">';
  echo '</head>';
  echo '<body>';
  echo $tr_cont['redir'].$seg.$tr_cont['redir1'].$tr_cont['back'].'.<br />';
  echo '<a href="http://'.$server_name.$MIURL.$miarr.'">'.$tr_cont['back'].'</a>';
  echo '</body>';
  echo '</html>';
?>
